package com.dcit.logging.model;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class SysOperationLogExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public SysOperationLogExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNull() {
            addCriterion("user_id is null");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNotNull() {
            addCriterion("user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUserIdEqualTo(String value) {
            addCriterion("user_id =", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotEqualTo(String value) {
            addCriterion("user_id <>", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThan(String value) {
            addCriterion("user_id >", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThanOrEqualTo(String value) {
            addCriterion("user_id >=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThan(String value) {
            addCriterion("user_id <", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThanOrEqualTo(String value) {
            addCriterion("user_id <=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLike(String value) {
            addCriterion("user_id like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotLike(String value) {
            addCriterion("user_id not like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdIn(List<String> values) {
            addCriterion("user_id in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotIn(List<String> values) {
            addCriterion("user_id not in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdBetween(String value1, String value2) {
            addCriterion("user_id between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotBetween(String value1, String value2) {
            addCriterion("user_id not between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andLogTypeIsNull() {
            addCriterion("log_type is null");
            return (Criteria) this;
        }

        public Criteria andLogTypeIsNotNull() {
            addCriterion("log_type is not null");
            return (Criteria) this;
        }

        public Criteria andLogTypeEqualTo(String value) {
            addCriterion("log_type =", value, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeNotEqualTo(String value) {
            addCriterion("log_type <>", value, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeGreaterThan(String value) {
            addCriterion("log_type >", value, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeGreaterThanOrEqualTo(String value) {
            addCriterion("log_type >=", value, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeLessThan(String value) {
            addCriterion("log_type <", value, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeLessThanOrEqualTo(String value) {
            addCriterion("log_type <=", value, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeLike(String value) {
            addCriterion("log_type like", value, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeNotLike(String value) {
            addCriterion("log_type not like", value, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeIn(List<String> values) {
            addCriterion("log_type in", values, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeNotIn(List<String> values) {
            addCriterion("log_type not in", values, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeBetween(String value1, String value2) {
            addCriterion("log_type between", value1, value2, "logType");
            return (Criteria) this;
        }

        public Criteria andLogTypeNotBetween(String value1, String value2) {
            addCriterion("log_type not between", value1, value2, "logType");
            return (Criteria) this;
        }

        public Criteria andUserIpIsNull() {
            addCriterion("user_ip is null");
            return (Criteria) this;
        }

        public Criteria andUserIpIsNotNull() {
            addCriterion("user_ip is not null");
            return (Criteria) this;
        }

        public Criteria andUserIpEqualTo(String value) {
            addCriterion("user_ip =", value, "userIp");
            return (Criteria) this;
        }

        public Criteria andUserIpNotEqualTo(String value) {
            addCriterion("user_ip <>", value, "userIp");
            return (Criteria) this;
        }

        public Criteria andUserIpGreaterThan(String value) {
            addCriterion("user_ip >", value, "userIp");
            return (Criteria) this;
        }

        public Criteria andUserIpGreaterThanOrEqualTo(String value) {
            addCriterion("user_ip >=", value, "userIp");
            return (Criteria) this;
        }

        public Criteria andUserIpLessThan(String value) {
            addCriterion("user_ip <", value, "userIp");
            return (Criteria) this;
        }

        public Criteria andUserIpLessThanOrEqualTo(String value) {
            addCriterion("user_ip <=", value, "userIp");
            return (Criteria) this;
        }

        public Criteria andUserIpLike(String value) {
            addCriterion("user_ip like", value, "userIp");
            return (Criteria) this;
        }

        public Criteria andUserIpNotLike(String value) {
            addCriterion("user_ip not like", value, "userIp");
            return (Criteria) this;
        }

        public Criteria andUserIpIn(List<String> values) {
            addCriterion("user_ip in", values, "userIp");
            return (Criteria) this;
        }

        public Criteria andUserIpNotIn(List<String> values) {
            addCriterion("user_ip not in", values, "userIp");
            return (Criteria) this;
        }

        public Criteria andUserIpBetween(String value1, String value2) {
            addCriterion("user_ip between", value1, value2, "userIp");
            return (Criteria) this;
        }

        public Criteria andUserIpNotBetween(String value1, String value2) {
            addCriterion("user_ip not between", value1, value2, "userIp");
            return (Criteria) this;
        }

        public Criteria andRequestApiIsNull() {
            addCriterion("request_api is null");
            return (Criteria) this;
        }

        public Criteria andRequestApiIsNotNull() {
            addCriterion("request_api is not null");
            return (Criteria) this;
        }

        public Criteria andRequestApiEqualTo(String value) {
            addCriterion("request_api =", value, "requestApi");
            return (Criteria) this;
        }

        public Criteria andRequestApiNotEqualTo(String value) {
            addCriterion("request_api <>", value, "requestApi");
            return (Criteria) this;
        }

        public Criteria andRequestApiGreaterThan(String value) {
            addCriterion("request_api >", value, "requestApi");
            return (Criteria) this;
        }

        public Criteria andRequestApiGreaterThanOrEqualTo(String value) {
            addCriterion("request_api >=", value, "requestApi");
            return (Criteria) this;
        }

        public Criteria andRequestApiLessThan(String value) {
            addCriterion("request_api <", value, "requestApi");
            return (Criteria) this;
        }

        public Criteria andRequestApiLessThanOrEqualTo(String value) {
            addCriterion("request_api <=", value, "requestApi");
            return (Criteria) this;
        }

        public Criteria andRequestApiLike(String value) {
            addCriterion("request_api like", value, "requestApi");
            return (Criteria) this;
        }

        public Criteria andRequestApiNotLike(String value) {
            addCriterion("request_api not like", value, "requestApi");
            return (Criteria) this;
        }

        public Criteria andRequestApiIn(List<String> values) {
            addCriterion("request_api in", values, "requestApi");
            return (Criteria) this;
        }

        public Criteria andRequestApiNotIn(List<String> values) {
            addCriterion("request_api not in", values, "requestApi");
            return (Criteria) this;
        }

        public Criteria andRequestApiBetween(String value1, String value2) {
            addCriterion("request_api between", value1, value2, "requestApi");
            return (Criteria) this;
        }

        public Criteria andRequestApiNotBetween(String value1, String value2) {
            addCriterion("request_api not between", value1, value2, "requestApi");
            return (Criteria) this;
        }

        public Criteria andFormMethodIsNull() {
            addCriterion("form_method is null");
            return (Criteria) this;
        }

        public Criteria andFormMethodIsNotNull() {
            addCriterion("form_method is not null");
            return (Criteria) this;
        }

        public Criteria andFormMethodEqualTo(String value) {
            addCriterion("form_method =", value, "formMethod");
            return (Criteria) this;
        }

        public Criteria andFormMethodNotEqualTo(String value) {
            addCriterion("form_method <>", value, "formMethod");
            return (Criteria) this;
        }

        public Criteria andFormMethodGreaterThan(String value) {
            addCriterion("form_method >", value, "formMethod");
            return (Criteria) this;
        }

        public Criteria andFormMethodGreaterThanOrEqualTo(String value) {
            addCriterion("form_method >=", value, "formMethod");
            return (Criteria) this;
        }

        public Criteria andFormMethodLessThan(String value) {
            addCriterion("form_method <", value, "formMethod");
            return (Criteria) this;
        }

        public Criteria andFormMethodLessThanOrEqualTo(String value) {
            addCriterion("form_method <=", value, "formMethod");
            return (Criteria) this;
        }

        public Criteria andFormMethodLike(String value) {
            addCriterion("form_method like", value, "formMethod");
            return (Criteria) this;
        }

        public Criteria andFormMethodNotLike(String value) {
            addCriterion("form_method not like", value, "formMethod");
            return (Criteria) this;
        }

        public Criteria andFormMethodIn(List<String> values) {
            addCriterion("form_method in", values, "formMethod");
            return (Criteria) this;
        }

        public Criteria andFormMethodNotIn(List<String> values) {
            addCriterion("form_method not in", values, "formMethod");
            return (Criteria) this;
        }

        public Criteria andFormMethodBetween(String value1, String value2) {
            addCriterion("form_method between", value1, value2, "formMethod");
            return (Criteria) this;
        }

        public Criteria andFormMethodNotBetween(String value1, String value2) {
            addCriterion("form_method not between", value1, value2, "formMethod");
            return (Criteria) this;
        }

        public Criteria andRequestArgsIsNull() {
            addCriterion("request_args is null");
            return (Criteria) this;
        }

        public Criteria andRequestArgsIsNotNull() {
            addCriterion("request_args is not null");
            return (Criteria) this;
        }

        public Criteria andRequestArgsEqualTo(String value) {
            addCriterion("request_args =", value, "requestArgs");
            return (Criteria) this;
        }

        public Criteria andRequestArgsNotEqualTo(String value) {
            addCriterion("request_args <>", value, "requestArgs");
            return (Criteria) this;
        }

        public Criteria andRequestArgsGreaterThan(String value) {
            addCriterion("request_args >", value, "requestArgs");
            return (Criteria) this;
        }

        public Criteria andRequestArgsGreaterThanOrEqualTo(String value) {
            addCriterion("request_args >=", value, "requestArgs");
            return (Criteria) this;
        }

        public Criteria andRequestArgsLessThan(String value) {
            addCriterion("request_args <", value, "requestArgs");
            return (Criteria) this;
        }

        public Criteria andRequestArgsLessThanOrEqualTo(String value) {
            addCriterion("request_args <=", value, "requestArgs");
            return (Criteria) this;
        }

        public Criteria andRequestArgsLike(String value) {
            addCriterion("request_args like", value, "requestArgs");
            return (Criteria) this;
        }

        public Criteria andRequestArgsNotLike(String value) {
            addCriterion("request_args not like", value, "requestArgs");
            return (Criteria) this;
        }

        public Criteria andRequestArgsIn(List<String> values) {
            addCriterion("request_args in", values, "requestArgs");
            return (Criteria) this;
        }

        public Criteria andRequestArgsNotIn(List<String> values) {
            addCriterion("request_args not in", values, "requestArgs");
            return (Criteria) this;
        }

        public Criteria andRequestArgsBetween(String value1, String value2) {
            addCriterion("request_args between", value1, value2, "requestArgs");
            return (Criteria) this;
        }

        public Criteria andRequestArgsNotBetween(String value1, String value2) {
            addCriterion("request_args not between", value1, value2, "requestArgs");
            return (Criteria) this;
        }

        public Criteria andClassMethodIsNull() {
            addCriterion("class_method is null");
            return (Criteria) this;
        }

        public Criteria andClassMethodIsNotNull() {
            addCriterion("class_method is not null");
            return (Criteria) this;
        }

        public Criteria andClassMethodEqualTo(String value) {
            addCriterion("class_method =", value, "classMethod");
            return (Criteria) this;
        }

        public Criteria andClassMethodNotEqualTo(String value) {
            addCriterion("class_method <>", value, "classMethod");
            return (Criteria) this;
        }

        public Criteria andClassMethodGreaterThan(String value) {
            addCriterion("class_method >", value, "classMethod");
            return (Criteria) this;
        }

        public Criteria andClassMethodGreaterThanOrEqualTo(String value) {
            addCriterion("class_method >=", value, "classMethod");
            return (Criteria) this;
        }

        public Criteria andClassMethodLessThan(String value) {
            addCriterion("class_method <", value, "classMethod");
            return (Criteria) this;
        }

        public Criteria andClassMethodLessThanOrEqualTo(String value) {
            addCriterion("class_method <=", value, "classMethod");
            return (Criteria) this;
        }

        public Criteria andClassMethodLike(String value) {
            addCriterion("class_method like", value, "classMethod");
            return (Criteria) this;
        }

        public Criteria andClassMethodNotLike(String value) {
            addCriterion("class_method not like", value, "classMethod");
            return (Criteria) this;
        }

        public Criteria andClassMethodIn(List<String> values) {
            addCriterion("class_method in", values, "classMethod");
            return (Criteria) this;
        }

        public Criteria andClassMethodNotIn(List<String> values) {
            addCriterion("class_method not in", values, "classMethod");
            return (Criteria) this;
        }

        public Criteria andClassMethodBetween(String value1, String value2) {
            addCriterion("class_method between", value1, value2, "classMethod");
            return (Criteria) this;
        }

        public Criteria andClassMethodNotBetween(String value1, String value2) {
            addCriterion("class_method not between", value1, value2, "classMethod");
            return (Criteria) this;
        }

        public Criteria andSucceedIsNull() {
            addCriterion("succeed is null");
            return (Criteria) this;
        }

        public Criteria andSucceedIsNotNull() {
            addCriterion("succeed is not null");
            return (Criteria) this;
        }

        public Criteria andSucceedEqualTo(String value) {
            addCriterion("succeed =", value, "succeed");
            return (Criteria) this;
        }

        public Criteria andSucceedNotEqualTo(String value) {
            addCriterion("succeed <>", value, "succeed");
            return (Criteria) this;
        }

        public Criteria andSucceedGreaterThan(String value) {
            addCriterion("succeed >", value, "succeed");
            return (Criteria) this;
        }

        public Criteria andSucceedGreaterThanOrEqualTo(String value) {
            addCriterion("succeed >=", value, "succeed");
            return (Criteria) this;
        }

        public Criteria andSucceedLessThan(String value) {
            addCriterion("succeed <", value, "succeed");
            return (Criteria) this;
        }

        public Criteria andSucceedLessThanOrEqualTo(String value) {
            addCriterion("succeed <=", value, "succeed");
            return (Criteria) this;
        }

        public Criteria andSucceedLike(String value) {
            addCriterion("succeed like", value, "succeed");
            return (Criteria) this;
        }

        public Criteria andSucceedNotLike(String value) {
            addCriterion("succeed not like", value, "succeed");
            return (Criteria) this;
        }

        public Criteria andSucceedIn(List<String> values) {
            addCriterion("succeed in", values, "succeed");
            return (Criteria) this;
        }

        public Criteria andSucceedNotIn(List<String> values) {
            addCriterion("succeed not in", values, "succeed");
            return (Criteria) this;
        }

        public Criteria andSucceedBetween(String value1, String value2) {
            addCriterion("succeed between", value1, value2, "succeed");
            return (Criteria) this;
        }

        public Criteria andSucceedNotBetween(String value1, String value2) {
            addCriterion("succeed not between", value1, value2, "succeed");
            return (Criteria) this;
        }

        public Criteria andReturnMessageIsNull() {
            addCriterion("return_message is null");
            return (Criteria) this;
        }

        public Criteria andReturnMessageIsNotNull() {
            addCriterion("return_message is not null");
            return (Criteria) this;
        }

        public Criteria andReturnMessageEqualTo(String value) {
            addCriterion("return_message =", value, "returnMessage");
            return (Criteria) this;
        }

        public Criteria andReturnMessageNotEqualTo(String value) {
            addCriterion("return_message <>", value, "returnMessage");
            return (Criteria) this;
        }

        public Criteria andReturnMessageGreaterThan(String value) {
            addCriterion("return_message >", value, "returnMessage");
            return (Criteria) this;
        }

        public Criteria andReturnMessageGreaterThanOrEqualTo(String value) {
            addCriterion("return_message >=", value, "returnMessage");
            return (Criteria) this;
        }

        public Criteria andReturnMessageLessThan(String value) {
            addCriterion("return_message <", value, "returnMessage");
            return (Criteria) this;
        }

        public Criteria andReturnMessageLessThanOrEqualTo(String value) {
            addCriterion("return_message <=", value, "returnMessage");
            return (Criteria) this;
        }

        public Criteria andReturnMessageLike(String value) {
            addCriterion("return_message like", value, "returnMessage");
            return (Criteria) this;
        }

        public Criteria andReturnMessageNotLike(String value) {
            addCriterion("return_message not like", value, "returnMessage");
            return (Criteria) this;
        }

        public Criteria andReturnMessageIn(List<String> values) {
            addCriterion("return_message in", values, "returnMessage");
            return (Criteria) this;
        }

        public Criteria andReturnMessageNotIn(List<String> values) {
            addCriterion("return_message not in", values, "returnMessage");
            return (Criteria) this;
        }

        public Criteria andReturnMessageBetween(String value1, String value2) {
            addCriterion("return_message between", value1, value2, "returnMessage");
            return (Criteria) this;
        }

        public Criteria andReturnMessageNotBetween(String value1, String value2) {
            addCriterion("return_message not between", value1, value2, "returnMessage");
            return (Criteria) this;
        }

        public Criteria andFailedMessageIsNull() {
            addCriterion("failed_message is null");
            return (Criteria) this;
        }

        public Criteria andFailedMessageIsNotNull() {
            addCriterion("failed_message is not null");
            return (Criteria) this;
        }

        public Criteria andFailedMessageEqualTo(String value) {
            addCriterion("failed_message =", value, "failedMessage");
            return (Criteria) this;
        }

        public Criteria andFailedMessageNotEqualTo(String value) {
            addCriterion("failed_message <>", value, "failedMessage");
            return (Criteria) this;
        }

        public Criteria andFailedMessageGreaterThan(String value) {
            addCriterion("failed_message >", value, "failedMessage");
            return (Criteria) this;
        }

        public Criteria andFailedMessageGreaterThanOrEqualTo(String value) {
            addCriterion("failed_message >=", value, "failedMessage");
            return (Criteria) this;
        }

        public Criteria andFailedMessageLessThan(String value) {
            addCriterion("failed_message <", value, "failedMessage");
            return (Criteria) this;
        }

        public Criteria andFailedMessageLessThanOrEqualTo(String value) {
            addCriterion("failed_message <=", value, "failedMessage");
            return (Criteria) this;
        }

        public Criteria andFailedMessageLike(String value) {
            addCriterion("failed_message like", value, "failedMessage");
            return (Criteria) this;
        }

        public Criteria andFailedMessageNotLike(String value) {
            addCriterion("failed_message not like", value, "failedMessage");
            return (Criteria) this;
        }

        public Criteria andFailedMessageIn(List<String> values) {
            addCriterion("failed_message in", values, "failedMessage");
            return (Criteria) this;
        }

        public Criteria andFailedMessageNotIn(List<String> values) {
            addCriterion("failed_message not in", values, "failedMessage");
            return (Criteria) this;
        }

        public Criteria andFailedMessageBetween(String value1, String value2) {
            addCriterion("failed_message between", value1, value2, "failedMessage");
            return (Criteria) this;
        }

        public Criteria andFailedMessageNotBetween(String value1, String value2) {
            addCriterion("failed_message not between", value1, value2, "failedMessage");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}